#!/usr/bin/perl
use Crypt::Blowfish;

my $path = "/usr/local/apache/htdocs/audio";
my $pathurl = "/audio";

my $vmroot = "/var/lib/asterisk/sounds/custom";
my $defaultVmRoot = "/var/lib/asterisk/sounds";

my $string = $ENV{QUERY_STRING};

open(KEY, "</etc/asterisk/key") || die "can't open key file: $!";
chomp(my $key = <KEY>);
close(KEY);

$key = pack("H78", $key);
my $cipher = new Crypt::Blowfish $key;

my $text;
my @blocks = unpack("a16" x (int(length($string) / 8) + 1), $string);
foreach my $block (@blocks)
{
	last unless $block;
	$text .= $cipher->decrypt(pack("H16", $block));
	$text =~ s/[^\w\s\-\,\.\/\:\?\`]//g;
}
$text =~ s/(?:\.wav)?\s*$/.wav/;

my $file = "$vmroot/$text";

if (-e $file && $text ne "")
{
	print "Location: " . randpath($file) . "\r\n\r\n";
} else {
	$file = "$defaultVmRoot/$text";
	
	if (-e $file) {
		print "Location: " . randpath($file) . "\r\n\r\n";
	} else {
		print "Content-Type: text/html\n\n";
        	print "File ^$text^ cannot be found in either directories:<br/><br/>\n\n"
			. "- $vmroot<br/>\n"
			. "- $defaultVmRoot<br/><br/>\n\n"
			. "text: $text<br/>\n"
			. "query: $string";
	}
}

sub randpath
{
	my $wav = shift;
	my @chars = ("a".."z","A".."Z",0..9);

	my $url = "$pathurl/";
	my $rand;

	foreach (1 .. 12)
	{
		$rand .= $chars[int(rand(@chars))];
	}

	link($wav, "$path/$rand.wav");
	chmod(0755, "$path/$rand.wav");

	return "$pathurl/$rand.wav";
}
